> ## Documentation Index
> Fetch the complete documentation index at: https://docs.givebutter.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Update a contact



## OpenAPI

````yaml https://givebutter.com/docs/api.json put /v1/contacts/{contact}
openapi: 3.1.0
info:
  title: Givebutter API Documentation
  version: 1.0.0
  description: >-
    Givebutter Public API - Access and manage your campaigns, contacts,
    transactions, and more.
servers:
  - url: https://api.givebutter.com/
security:
  - http: []
paths:
  /v1/contacts/{contact}:
    put:
      tags:
        - Contacts
      summary: Update a contact
      operationId: contacts.update
      parameters:
        - name: contact
          in: path
          required: true
          description: The contact ID
          schema:
            type: integer
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/UpdateContactRequest'
      responses:
        '200':
          description: '`ContactResource`'
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ContactResource'
        '403':
          $ref: '#/components/responses/AuthorizationException'
        '404':
          $ref: '#/components/responses/ModelNotFoundException'
        '422':
          $ref: '#/components/responses/ValidationException'
components:
  schemas:
    UpdateContactRequest:
      type: object
      properties:
        first_name:
          type:
            - string
            - 'null'
          description: >-
            Required for individual contacts. Optional for company contacts,
            which require company_name instead.
          maxLength: 255
        last_name:
          type:
            - string
            - 'null'
          description: >-
            Required for individual contacts. Optional for company contacts,
            which require company_name instead.
          maxLength: 255
        middle_name:
          type:
            - string
            - 'null'
          maxLength: 255
        preferred_name:
          type:
            - string
            - 'null'
          minLength: 1
          maxLength: 255
        gender:
          $ref: '#/components/schemas/GenderEnum'
        pronouns:
          type:
            - string
            - 'null'
          minLength: 1
          maxLength: 255
        suffix:
          type:
            - string
            - 'null'
          maxLength: 32
        prefix:
          type:
            - string
            - 'null'
          maxLength: 32
        type:
          $ref: '#/components/schemas/ContactType'
          description: >-
            Determines which fields are required: individual contacts require a
            name, company contacts require company_name.
        company_name:
          type:
            - string
            - 'null'
          description: >-
            Required for company contacts. Optional for individual contacts,
            which require first_name and last_name instead.
          maxLength: 255
        employer:
          type:
            - string
            - 'null'
          maxLength: 255
        company:
          type:
            - string
            - 'null'
          maxLength: 255
        title:
          type:
            - string
            - 'null'
          maxLength: 255
        twitter_url:
          type:
            - string
            - 'null'
        linkedin_url:
          type:
            - string
            - 'null'
        facebook_url:
          type:
            - string
            - 'null'
        tiktok_url:
          type:
            - string
            - 'null'
        website_url:
          type:
            - string
            - 'null'
          format: uri
          maxLength: 2048
        note:
          type:
            - string
            - 'null'
        bio:
          type:
            - string
            - 'null'
          maxLength: 2000
        external_id:
          type:
            - string
            - 'null'
          maxLength: 255
        contact_since:
          type:
            - string
            - 'null'
          format: date-time
        dob:
          type: string
        email_opt_in:
          type:
            - boolean
            - 'null'
        sms_opt_in:
          type:
            - boolean
            - 'null'
        address_subscription:
          type:
            - boolean
            - 'null'
        tags:
          type:
            - array
            - 'null'
          items:
            type: string
            maxLength: 64
        remove_emails:
          type:
            - array
            - 'null'
          items:
            type: string
            format: email
        remove_phones:
          type:
            - array
            - 'null'
          items:
            type: string
        remove_address_ids:
          type:
            - array
            - 'null'
          items:
            type: integer
        emails:
          type:
            - array
            - 'null'
          items:
            type: object
            properties:
              value:
                type:
                  - string
                  - 'null'
                format: email
              type:
                type:
                  - string
                  - 'null'
              is_primary:
                type: boolean
        phones:
          type:
            - array
            - 'null'
          items:
            type: object
            properties:
              value:
                type:
                  - string
                  - 'null'
              type:
                type:
                  - string
                  - 'null'
              is_primary:
                type: boolean
        addresses:
          type:
            - array
            - 'null'
          items:
            type: object
            properties:
              id:
                type: integer
              address_1:
                type:
                  - string
                  - 'null'
                maxLength: 255
              address_2:
                type:
                  - string
                  - 'null'
                maxLength: 255
              city:
                type:
                  - string
                  - 'null'
                maxLength: 255
              state:
                type:
                  - string
                  - 'null'
                maxLength: 255
              zipcode:
                type:
                  - string
                  - 'null'
                maxLength: 255
              country:
                type:
                  - string
                  - 'null'
                maxLength: 255
              is_primary:
                type: boolean
      title: UpdateContactRequest
    ContactResource:
      type: object
      properties:
        id:
          type: string
        external_id:
          type: string
        contact_since:
          type: string
        type:
          type: string
        prefix:
          type: string
        first_name:
          type: string
        preferred_name:
          type: string
        middle_name:
          type: string
        last_name:
          type: string
        suffix:
          type: string
        gender:
          type: string
        pronouns:
          type: string
        dob:
          type: string
        company:
          type: string
        employer:
          type: string
        company_name:
          type: string
        point_of_contact:
          anyOf:
            - $ref: '#/components/schemas/PointOfContactResource'
            - type: 'null'
        associated_companies:
          type:
            - array
            - 'null'
          items:
            $ref: '#/components/schemas/AssociatedCompanyResource'
        title:
          type: string
        website_url:
          type: string
        twitter_url:
          type: string
        linkedin_url:
          type: string
        facebook_url:
          type: string
        tiktok_url:
          type: string
        instagram_url:
          type: string
        emails:
          type: array
          items:
            $ref: '#/components/schemas/EmailResource'
        phones:
          type: array
          items:
            $ref: '#/components/schemas/PhoneResource'
        primary_email:
          type: string
        primary_phone:
          type: string
        note:
          type: string
        addresses:
          type: array
          items:
            $ref: '#/components/schemas/App.Http.Resources.API.AddressResource'
        primary_address:
          anyOf:
            - $ref: '#/components/schemas/App.Http.Resources.API.AddressResource'
            - type: 'null'
        last_donation_amount:
          type: string
        stats:
          type: object
          properties:
            total_contributions:
              type: string
            recurring_contributions:
              type: string
          required:
            - total_contributions
            - recurring_contributions
        tags:
          type: string
        custom_fields:
          type: array
          items: {}
        external_ids:
          type: array
          items:
            $ref: '#/components/schemas/ExternalIdResource'
        is_email_subscribed:
          type: string
        is_phone_subscribed:
          type: string
        is_address_subscribed:
          type: string
        email_opt_in:
          type: string
        sms_opt_in:
          type: string
        address_unsubscribed_at:
          type: string
        archived_at:
          type: string
        created_at:
          type: string
        updated_at:
          type: string
        salutation_name:
          type: string
      required:
        - id
        - external_id
        - contact_since
        - type
        - prefix
        - first_name
        - preferred_name
        - middle_name
        - last_name
        - suffix
        - gender
        - pronouns
        - dob
        - company
        - employer
        - company_name
        - title
        - website_url
        - twitter_url
        - linkedin_url
        - facebook_url
        - tiktok_url
        - instagram_url
        - emails
        - phones
        - primary_email
        - primary_phone
        - note
        - addresses
        - primary_address
        - last_donation_amount
        - stats
        - tags
        - custom_fields
        - external_ids
        - is_email_subscribed
        - is_phone_subscribed
        - is_address_subscribed
        - email_opt_in
        - sms_opt_in
        - address_unsubscribed_at
        - archived_at
        - created_at
        - updated_at
        - salutation_name
      title: ContactResource
    GenderEnum:
      type: string
      enum:
        - male
        - female
        - other
      title: GenderEnum
    ContactType:
      type: string
      enum:
        - individual
        - company
      title: ContactType
    PointOfContactResource:
      type: object
      properties:
        id:
          type: string
        type:
          type: string
        prefix:
          type: string
        first_name:
          type: string
        middle_name:
          type: string
        last_name:
          type: string
        suffix:
          type: string
        gender:
          type: string
        pronouns:
          type: string
        dob:
          type: string
        employer:
          type: string
        title:
          type: string
        twitter_url:
          type: string
        linkedin_url:
          type: string
        facebook_url:
          type: string
        tiktok_url:
          type: string
        instagram_url:
          type: string
        website_url:
          type: string
        emails:
          type: object
          additionalProperties: {}
        phones:
          type: object
          additionalProperties: {}
        primary_email:
          type: string
        primary_phone:
          type: string
        is_email_subscribed:
          type: string
        is_phone_subscribed:
          type: string
        is_address_subscribed:
          type: string
        address_unsubscribed_at:
          type: string
        archived_at:
          type: string
        created_at:
          type: string
        updated_at:
          type: string
        first_time_supporter_at:
          type: string
      required:
        - id
        - type
        - prefix
        - first_name
        - middle_name
        - last_name
        - suffix
        - gender
        - pronouns
        - dob
        - employer
        - title
        - twitter_url
        - linkedin_url
        - facebook_url
        - tiktok_url
        - instagram_url
        - website_url
        - emails
        - phones
        - primary_email
        - primary_phone
        - is_email_subscribed
        - is_phone_subscribed
        - is_address_subscribed
        - address_unsubscribed_at
        - archived_at
        - created_at
        - updated_at
        - first_time_supporter_at
      title: PointOfContactResource
    AssociatedCompanyResource:
      type: object
      properties:
        id:
          type: string
        type:
          type: string
        company_name:
          type: string
        name_display:
          type: string
        title:
          type: string
        twitter_url:
          type: string
        linkedin_url:
          type: string
        facebook_url:
          type: string
        tiktok_url:
          type: string
        instagram_url:
          type: string
        website_url:
          type: string
        image_url:
          type:
            - string
            - 'null'
        emails:
          type: object
          additionalProperties: {}
        phones:
          type: object
          additionalProperties: {}
        primary_email:
          type: string
        primary_phone:
          type: string
        is_email_subscribed:
          type: string
        is_phone_subscribed:
          type: string
        is_address_subscribed:
          type: string
        address_unsubscribed_at:
          type: string
        note:
          type: string
        addresses:
          type: array
          items:
            $ref: '#/components/schemas/AddressResource'
        primary_address:
          $ref: '#/components/schemas/AddressResource'
        archived_at:
          type: string
        created_at:
          type: string
        updated_at:
          type: string
        first_time_supporter_at:
          type: string
      required:
        - id
        - type
        - company_name
        - name_display
        - title
        - twitter_url
        - linkedin_url
        - facebook_url
        - tiktok_url
        - instagram_url
        - website_url
        - image_url
        - emails
        - phones
        - primary_email
        - primary_phone
        - is_email_subscribed
        - is_phone_subscribed
        - is_address_subscribed
        - address_unsubscribed_at
        - note
        - addresses
        - primary_address
        - archived_at
        - created_at
        - updated_at
        - first_time_supporter_at
      title: AssociatedCompanyResource
    EmailResource:
      type: object
      properties:
        type:
          type:
            - string
            - 'null'
        value:
          type:
            - string
            - 'null'
      required:
        - type
        - value
      title: EmailResource
    PhoneResource:
      type: object
      properties:
        type:
          type:
            - string
            - 'null'
        value:
          type:
            - string
            - 'null'
      required:
        - type
        - value
      title: PhoneResource
    App.Http.Resources.API.AddressResource:
      type: object
      properties:
        address_1:
          type: string
        address_2:
          type:
            - string
            - 'null'
        city:
          type: string
        state:
          type:
            - string
            - 'null'
        zipcode:
          type:
            - string
            - 'null'
        country:
          type: string
        type:
          type: string
        is_primary:
          type: boolean
        created_at:
          type:
            - string
            - 'null'
          format: date-time
        updated_at:
          type:
            - string
            - 'null'
          format: date-time
      required:
        - address_1
        - address_2
        - city
        - state
        - zipcode
        - country
        - type
        - is_primary
        - created_at
        - updated_at
      title: App.Http.Resources.API.AddressResource
    ExternalIdResource:
      type: object
      properties:
        id:
          type: integer
        label:
          type: string
        external_id:
          type: string
        created_at:
          type: string
        updated_at:
          type: string
      required:
        - id
        - label
        - external_id
        - created_at
        - updated_at
      title: ExternalIdResource
    AddressResource:
      type: object
      properties:
        id:
          type: integer
        account_id:
          type:
            - integer
            - 'null'
        name:
          type:
            - string
            - 'null'
        address_1:
          type: string
        address_2:
          type:
            - string
            - 'null'
        city:
          type: string
        state:
          type:
            - string
            - 'null'
        zipcode:
          type:
            - string
            - 'null'
        country:
          type: string
        type:
          type: string
        is_primary:
          type: boolean
        created_at:
          type:
            - string
            - 'null'
          format: date-time
        updated_at:
          type:
            - string
            - 'null'
          format: date-time
      required:
        - id
        - account_id
        - name
        - address_1
        - address_2
        - city
        - state
        - zipcode
        - country
        - type
        - is_primary
        - created_at
        - updated_at
      title: AddressResource
  responses:
    AuthorizationException:
      description: Authorization error
      content:
        application/json:
          schema:
            type: object
            properties:
              message:
                type: string
                description: Error overview.
            required:
              - message
    ModelNotFoundException:
      description: Not found
      content:
        application/json:
          schema:
            type: object
            properties:
              message:
                type: string
                description: Error overview.
            required:
              - message
    ValidationException:
      description: Validation error
      content:
        application/json:
          schema:
            type: object
            properties:
              message:
                type: string
                description: Errors overview.
              errors:
                type: object
                description: A detailed description of each field that failed validation.
                additionalProperties:
                  type: array
                  items:
                    type: string
            required:
              - message
              - errors
  securitySchemes:
    http:
      type: http
      scheme: bearer

````